#include <stdlib.h>
#include <stdio.h>

#include "list.h"

void print_list (character_list_t *str) {

  character_list_elmt_t *elem = character_list_head (str);
  for (; elem != character_list_tail (str); elem = character_list_next(elem)) {
    printf ("%c", character_list_data(elem));
  }
  printf ("%c\n", character_list_data(character_list_tail(str)));
}

int main(void)
{
  int size = 0;
  fscanf(stdin, "%d", &size);

  character_list_t *tab;
  tab = malloc (size * sizeof (character_list_t));
  if (tab == NULL) {
    return 1;
  }

  for (int i = 0; i < size; i++) {
    character_list_init (&(tab[i]));
  }

  char value = '0';
  int cpt = 0;
  while ( fscanf (stdin, "%c", &value) != EOF) {
    if (value != '\n') {
      character_list_ins_next (&tab[cpt],
			       character_list_tail (&tab[cpt]), value);
      cpt = (cpt + 1) % size;
    }
  }

  for (int i = 0; i < size; i++) {
    print_list (&tab[i]);
  }

  return 0;
}
